"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.entangledPairBeet = exports.EntangledPair = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const entangledPairDiscriminator = [133, 118, 20, 210, 1, 54, 172, 116];
class EntangledPair {
    constructor(treasuryMint, mintA, mintB, tokenAEscrow, tokenBEscrow, authority, bump, tokenAEscrowBump, tokenBEscrowBump, price, paid, paysEveryTime) {
        this.treasuryMint = treasuryMint;
        this.mintA = mintA;
        this.mintB = mintB;
        this.tokenAEscrow = tokenAEscrow;
        this.tokenBEscrow = tokenBEscrow;
        this.authority = authority;
        this.bump = bump;
        this.tokenAEscrowBump = tokenAEscrowBump;
        this.tokenBEscrowBump = tokenBEscrowBump;
        this.price = price;
        this.paid = paid;
        this.paysEveryTime = paysEveryTime;
    }
    static fromArgs(args) {
        return new EntangledPair(args.treasuryMint, args.mintA, args.mintB, args.tokenAEscrow, args.tokenBEscrow, args.authority, args.bump, args.tokenAEscrowBump, args.tokenBEscrowBump, args.price, args.paid, args.paysEveryTime);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return EntangledPair.deserialize(accountInfo.data, offset);
    }
    static async fromAccountAddress(connection, address) {
        const accountInfo = await connection.getAccountInfo(address);
        if (accountInfo == null) {
            throw new Error(`Unable to find EntangledPair account at ${address}`);
        }
        return EntangledPair.fromAccountInfo(accountInfo, 0)[0];
    }
    static deserialize(buf, offset = 0) {
        return exports.entangledPairBeet.deserialize(buf, offset);
    }
    serialize() {
        return exports.entangledPairBeet.serialize({
            accountDiscriminator: entangledPairDiscriminator,
            ...this,
        });
    }
    static get byteSize() {
        return exports.entangledPairBeet.byteSize;
    }
    static async getMinimumBalanceForRentExemption(connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(EntangledPair.byteSize, commitment);
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === EntangledPair.byteSize;
    }
    pretty() {
        return {
            treasuryMint: this.treasuryMint.toBase58(),
            mintA: this.mintA.toBase58(),
            mintB: this.mintB.toBase58(),
            tokenAEscrow: this.tokenAEscrow.toBase58(),
            tokenBEscrow: this.tokenBEscrow.toBase58(),
            authority: this.authority.toBase58(),
            bump: this.bump,
            tokenAEscrowBump: this.tokenAEscrowBump,
            tokenBEscrowBump: this.tokenBEscrowBump,
            price: (() => {
                const x = this.price;
                if (typeof x.toNumber === 'function') {
                    try {
                        return x.toNumber();
                    }
                    catch (_) {
                        return x;
                    }
                }
                return x;
            })(),
            paid: this.paid,
            paysEveryTime: this.paysEveryTime,
        };
    }
}
exports.EntangledPair = EntangledPair;
exports.entangledPairBeet = new beet.BeetStruct([
    ['accountDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['treasuryMint', beetSolana.publicKey],
    ['mintA', beetSolana.publicKey],
    ['mintB', beetSolana.publicKey],
    ['tokenAEscrow', beetSolana.publicKey],
    ['tokenBEscrow', beetSolana.publicKey],
    ['authority', beetSolana.publicKey],
    ['bump', beet.u8],
    ['tokenAEscrowBump', beet.u8],
    ['tokenBEscrowBump', beet.u8],
    ['price', beet.u64],
    ['paid', beet.bool],
    ['paysEveryTime', beet.bool],
], EntangledPair.fromArgs, 'EntangledPair');
//# sourceMappingURL=EntangledPair.js.map