declare type ErrorWithCode = Error & {
    code: number;
};
declare type MaybeErrorWithCode = ErrorWithCode | null | undefined;
export declare class PublicKeyMismatchError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidMintAuthorityError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class UninitializedAccountError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class IncorrectOwnerError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class PublicKeysShouldBeUniqueError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class StatementFalseError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class NotRentExemptError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class NumericalOverflowError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class DerivedKeyInvalidError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MetadataDoesntExistError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class EditionDoesntExistError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidTokenAmountError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidMintError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class EntangledPairExistsError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MustHaveSupplyOneError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class BumpSeedNotInHashMapError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare function errorFromCode(code: number): MaybeErrorWithCode;
export declare function errorFromName(name: string): MaybeErrorWithCode;
export {};
