import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type CreateEntangledPairInstructionArgs = {
    bump: number;
    reverseBump: number;
    tokenAEscrowBump: number;
    tokenBEscrowBump: number;
    price: beet.bignum;
    paysEveryTime: boolean;
};
export declare type CreateEntangledPairInstructionAccounts = {
    treasuryMint: web3.PublicKey;
    payer: web3.PublicKey;
    transferAuthority: web3.PublicKey;
    authority: web3.PublicKey;
    mintA: web3.PublicKey;
    metadataA: web3.PublicKey;
    editionA: web3.PublicKey;
    mintB: web3.PublicKey;
    metadataB: web3.PublicKey;
    editionB: web3.PublicKey;
    tokenB: web3.PublicKey;
    tokenAEscrow: web3.PublicKey;
    tokenBEscrow: web3.PublicKey;
    entangledPair: web3.PublicKey;
    reverseEntangledPair: web3.PublicKey;
};
export declare function createCreateEntangledPairInstruction(accounts: CreateEntangledPairInstructionAccounts, args: CreateEntangledPairInstructionArgs): web3.TransactionInstruction;
