"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSwapInstruction = void 0;
const splToken = __importStar(require("@solana/spl-token"));
const beet = __importStar(require("@metaplex-foundation/beet"));
const web3 = __importStar(require("@solana/web3.js"));
const swapStruct = new beet.BeetArgsStruct([['instructionDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)]], 'SwapInstructionArgs');
const swapInstructionDiscriminator = [248, 198, 158, 145, 225, 117, 135, 200];
function createSwapInstruction(accounts) {
    const { treasuryMint, payer, paymentAccount, paymentTransferAuthority, token, tokenMint, replacementTokenMetadata, replacementTokenMint, replacementToken, transferAuthority, tokenAEscrow, tokenBEscrow, entangledPair, } = accounts;
    const [data] = swapStruct.serialize({
        instructionDiscriminator: swapInstructionDiscriminator,
    });
    const keys = [
        {
            pubkey: treasuryMint,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: payer,
            isWritable: false,
            isSigner: true,
        },
        {
            pubkey: paymentAccount,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: paymentTransferAuthority,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: token,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: tokenMint,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: replacementTokenMetadata,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: replacementTokenMint,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: replacementToken,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: transferAuthority,
            isWritable: false,
            isSigner: true,
        },
        {
            pubkey: tokenAEscrow,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: tokenBEscrow,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: entangledPair,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: splToken.TOKEN_PROGRAM_ID,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: web3.SystemProgram.programId,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: splToken.ASSOCIATED_TOKEN_PROGRAM_ID,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: web3.SYSVAR_RENT_PUBKEY,
            isWritable: false,
            isSigner: false,
        },
    ];
    const ix = new web3.TransactionInstruction({
        programId: new web3.PublicKey('qntmGodpGkrM42mN68VCZHXnKqDCT8rdY23wFcXCLPd'),
        keys,
        data,
    });
    return ix;
}
exports.createSwapInstruction = createSwapInstruction;
//# sourceMappingURL=swap.js.map